VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Counter"
   ClientHeight    =   3015
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3015
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer timercheck 
      Left            =   120
      Top             =   1440
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start "
      Height          =   615
      Left            =   960
      TabIndex        =   0
      Top             =   960
      Width           =   2175
   End
   Begin VB.Label lblCount 
      BackColor       =   &H00E0E0E0&
      Height          =   255
      Left            =   2040
      TabIndex        =   3
      Top             =   1920
      Width           =   1215
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Count: "
      Height          =   255
      Left            =   1080
      TabIndex        =   2
      Top             =   1920
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Hit the 'Start' button to begin counting the pulses on Port 2, bit 0."
      Height          =   495
      Left            =   720
      TabIndex        =   1
      Top             =   240
      Width           =   3375
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   This a sample program for Winford Engineering's WECRD155B I/O Card.
'   This program uses Winford Engineering's Portal API
'   Hardware setup:
'       This program assumes that you have eight LEDs connected
'       to port 1 (port A) of your I/O card.  It also assumes that you have
'       a bounceless pushbutton (or a low frequency clock source)
'       connected between Bit 0 of port 2 (port B) and ground.
'   Operation:
'       This program keeps a count of how many times the pushbutton
'       has been pressed.  The count begins at 0 and is incremented
'       every time the button is pressed.  To monitor the state of the
'       pushbutton, the program configures Port 2 to be in the input state.
'       The current value is output onto Port 1; if you have LEDs connected
'       you will be able to see the value of the counter in binary form.
'       Notice that since Port 1 is configured for output operation, you
'       should take care that you do not have any circuitry connected
'       to port 1 that could interfere with the port's outputs (See the
'       section in your manual about Data Contention).

'Dimension form-level variables
 Dim hCard As Long          'holds the identifier returned by we_OpenCard

Private Sub cmdStart_Click()
  timercheck.Interval = 1
  timercheck.Enabled = True
   
End Sub

Private Sub Form_Load()
   'Dimension variables
    Dim result As Long      'holds the error or success code from API calls
    Dim msg As String       'message to output to user
    
   '*********************************************
   'First,we will output a notice and ask for user confirmation.
   'This would not normally be done in an actual application.
   msg = "Note:  This program configures Port 1 as an output port. " & _
         "Please be sure that you do not have interfering hardware " & _
         "connected to Port 1 of your card." & vbCrLf & vbCrLf & _
         "Press Ok to continue or Cancel to exit the program."
   If MsgBox(msg, vbExclamation + vbOKCancel) = vbCancel Then
      'User hit Cancel --> End program
      End
   End If
   
   '*********************************************
   'Open the card.  This should be the first API call in every program.
   'If your card is not configured for base address 384, edit the line below
   'to match your base address.
   hCard = we_OpenCard(WECRD_155B, 384)
   
   'Check if error occurred while trying to open the card
   If hCard < 0 Then        'Error occurred
      'Display error message
      msg = "An error occurred while opening the card.  Check that your card " & _
            "is configured for the base address used in the source code."
      MsgBox msg
      'Release card handle
      Call we_CloseCard(hCard)
      'End Program
      End
   End If
   
   
   '*********************************************
   'We now need to configure Port 1 (A) to be in OUTPUT mode
   result = we_ConfigureCard(hCard, 1, WECRD_OUTPUT)
   
   'Check if error occurred while configuring the port
   'Note that in a normal application, it would not be necessary to
   ' check for errors after all of the functions; but it is done here
   ' to show that it is possible
   If result < 0 Then       'Error occurred
      'Display error message
      msg = "An error occurred while configuring the Port 1"
      MsgBox msg
      'Release card handle
      Call we_CloseCard(hCard)
      'End Program
      End
   End If
   
   
   '*********************************************
   'We now need to configure Port 2 (B) to be in input mode
   result = we_ConfigureCard(hCard, 2, WECRD_INPUT)
   
   'Check if error occurred while configuring the port
   If result < 0 Then       'Error occurred
      'Display error message
      msg = "An error occurred while configuring Port 2"
      MsgBox msg
      'Release card handle
      Call we_CloseCard(hCard)
      'End Program
      End
   End If
   
   '*********************************************
   
End Sub


Private Sub timercheck_Timer()
   'Dimension variables
   'Static variables retain their value from one execution of this function
   ' to the next.
    Static count As Long      'counter of how many times the button has been pressed
    Static last_level As Boolean  ' Was the clock/switch line high or low last time? (True=high)
    Dim Value As Long       ' value read from Port 2
    Dim level As Boolean    ' level (true=high, false=low) of just the one bit we're interested in
    Dim result As Long      'holds the error or success code from API calls
    
    'Read input port
    result = we_InputValue(hCard, 2, Value)
    'Check for error during input operation
    If result < 0 Then    'Error occurred
       'Display error message
       MsgBox "An error occurred while reading a value."
       'Release card handle
       Call we_CloseCard(hCard)
       'stop timer from firing
       timercheck.Enabled = False
    End If
    
    ' Look at only bit 0 by And-ing with 1
    level = (Value And 1)
    
    'In this program, we will assume that when the input button is pressed,
    ' it results in Bit 0 going low (0).  When the input line goes low, we
    ' increment the counter
    
    ' We only take action on the falling edge of the signal, that is when the
    ' level of the signal last time was high and the level this time is low.
    If (last_level = True) And (level = False) Then
      ' last time the input was high
      ' If the bit has now gone low, it's time to increment our counter
      count = count + 1      'increment counter
      lblCount.Caption = count        'display current count value on the screen
      
      'Write current count value to the output port
      result = we_OutputValue(hCard, 1, count)
      'Check for error during output operation
      If result < 0 Then     'Error occurred
         'Display error message
         MsgBox "An error occurred while writing a value"
         'Release card handle
         Call we_CloseCard(hCard)
         'stop timer from firing
         timercheck.Enabled = False
      End If
    End If
    
    ' Regardless of what level the signal was that we just read, we
    ' need to remember it for next time so we can compare to it.
    last_level = level
            

End Sub
